#version 150

#include "/include.glsl"

/* DRAWBUFFERS:0 */
out vec4 outColor0;

uniform sampler2D depthtex0;
uniform sampler2D colortex0;
uniform sampler2D colortex2;

in vec2 texCoord;

void main() {
    vec3 outColor = texture(colortex0, texCoord).rgb;
    float transparency = texture(colortex0, texCoord).a;
    float depth = linearizeDepth(texture(depthtex0, texCoord).r);

    #ifdef EnableGreyscale
        vec4 data = texture(colortex2, texCoord);

        float colorPercent = 0.0;

        #ifdef RemoveGreyscaleFromBlocklight
            colorPercent += data.r;
        #endif

        #ifdef RemoveGreyscaleFromSkylight
            colorPercent += data.g;
        #endif

        #ifdef RemoveGreyscaleAroundPlayer
            float distancePercent = depth / GreyscaleDistance;
            colorPercent += clamp(-distancePercent + 1.0, 0, 1);
        #endif

        #ifndef SkyAlwaysGreyscale
            colorPercent += step(0.9, depth / far);
        #endif

        colorPercent = clamp(colorPercent, 0, 1);

        #ifdef ReverseGreyscale
            colorPercent = (colorPercent - 1.0) * -1.0;
        #endif

        vec3 greyOutColor = vec3(getLuminosity(outColor));

        outColor = mix(greyOutColor, outColor, colorPercent);
    #endif

    outColor0 = vec4(outColor, transparency);
}